/*
   SendeFrameLibrary.h
*/
#ifndef SENDE_FRAME_LIBRARY_H
#define SENDE_FRAME_LIBRARY_H

#include <windows.h>
#include <commdlg.h>
#include <string.h>
#include <io.h>
#include <memory.h>

#ifdef SENDEFRAMEDLL_EXPORTS
#define LIBSPEC _declspec(dllexport)
#else
#define LIBSPEC _declspec(dllimport)
#endif
#ifdef  __cplusplus
extern "C" {
#endif
 
#define STDCALL __stdcall

// Betriebsartenwechsel Automatik -> Parameterbertragung
#define BA_WECHSEL_PARAMETER 0x01
// Betriebsartenwechsel Parameterbertragung -> Automatik
#define BA_WECHSEL_AUTOMATIK 0x02

// Die jeweils erlaubten Wertebereiche fr ber HBYTE und LBYTE adressierenden
// Parameter sind in eckigen, Default-Werte in runden Klammern angegeben

#define HBYTE_MOTORTEST									0x00
#define LBYTE_MOTORTEST_WEGLAENGE_LONG							0x00	// Schritte	(400)   [0 bis 65535]
#define LBYTE_MOTORTEST_START_STOP_FLOAT						0x01	// mm/s	    (0.50)  [0.1 bis 999.0]
#define LBYTE_MOTORTEST_MAXGESCHWINDIGKEIT_FLOAT				0x02	// mm/s	    (10.00) [0.1 bis 999.0]
#define LBYTE_MOTORTEST_BESCHLEUNIGUNG_LONG						0x03	// mm/s	(10)    [1 bis 999]
//------------------------------------------------------------------------------------------------------
#define HBYTE_GESCHWINDIGKEITEN							0x01
#define LBYTE_GESCHWINDIGKEITEN_START_STOP_FLOAT				0x00	// mm/s	(0.50)  [0.1 bis 999.0]
#define LBYTE_GESCHWINDIGKEITEN_FAHR_FLOAT						0x01	// mm/s (4.00)  [0.1 bis 999.0]
#define LBYTE_GESCHWINDIGKEITEN_EILGANG_FLOAT					0x02	// mm/s (10.00) [0.1 bis 999.0]
#define LBYTE_GESCHWINDIGKEITEN_MANUEL_LANGSAM_FLOAT			0x03	// mm/s (0.50)  [0.1 bis 999.0]
#define LBYTE_GESCHWINDIGKEITEN_MANUEL_SCHNELL_FLOAT			0x04	// mm/s (2.50)  [0.1 bis 999.0]
#define LBYTE_GESCHWINDIGKEITEN_REFERENZFAHRT_FLOAT				0x05	// mm/s (2.50)  [0.1 bis 999.0]
#define LBYTE_GESCHWINDIGKEITEN_REFERENZFAHRT_FREI_FLOAT		0x06	// mm/s (0.50)  [0.1 bis 999.0]
#define LBYTE_GESCHWINDIGKEITEN_BESCHLEUNIGUNG_LONG				0x07	// mm/s (4)    [1 bis 999]
#define LBYTE_GESCHWINDIGKEITEN_BREMSWINKEL_LONG				0x08	// noch nicht vorhanden
#define LBYTE_GESCHWINDIGKEITEN_UMSCHALTZEIT_LONG				0x09	// noch nicht vorhanden
//------------------------------------------------------------------------------------------------------
#define HBYTE_SCHNITTSTELLE								0x02
#define LBYTE_SCHNITTSTELLE_ZUSATZSIGNAL_SPINDEL_LONG			0x00	// (3) [1-LowAktiv,2-HighAktiv,3-deaktiv]
#define LBYTE_SCHNITTSTELLE_ZUSATZSIGNAL_KUEHLUNG_LONG			0x01	// (3) [1-LowAktiv,2-HighAktiv,3-deaktiv]
#define LBYTE_SCHNITTSTELLE_ZUSATZSIGNAL_STROMABSENKUNG_LONG	0x02	// (3) [1-LowAktiv,2-HighAktiv,3-deaktiv]
#define LBYTE_SCHNITTSTELLE_ZUSATZSIGNAL_BOOST_LONG				0x03	// (3) [1-LowAktiv,2-HighAktiv,3-deaktiv]
//------------------------------------------------------------------------------------------------------
#define HBYTE_REFERENZFAHRT								0x03
#define LBYTE_REFERENZFAHRT_REFERENZ_X_UCHAR					0x00	// noch nicht vorhanden
#define LBYTE_REFERENZFAHRT_REFERENZ_Y_UCHAR					0x01	// noch nicht vorhanden
#define LBYTE_REFERENZFAHRT_REFERENZ_Z_UCHAR					0x02	// noch nicht vorhanden
#define LBYTE_REFERENZFAHRT_REFERENZ_C_UCHAR					0x03	// noch nicht vorhanden
#define LBYTE_REFERENZFAHRT_RICHTUNG_UND_REIHENFOLGE_UCHAR		0x04
#define LBYTE_REFERENZFAHRT_ENDSCHALTER_UCHAR		            0x05
//------------------------------------------------------------------------------------------------------
#define HBYTE_MECHANIK									0x04
#define LBYTE_MECHANIK_AUFLOESUNG_X_FLOAT						0x00	// Schritte/mm (100.00) [0.1 bis 999.0]
#define LBYTE_MECHANIK_AUFLOESUNG_Y_FLOAT						0x01	// Schritte/mm (100.00) [0.1 bis 999.0]
#define LBYTE_MECHANIK_AUFLOESUNG_Z_FLOAT						0x02	// Schritte/mm (100.00) [0.1 bis 999.0]
#define LBYTE_MECHANIK_AUFLOESUNG_C_FLOAT						0x03	// Schritte/mm (100.00) [0.1 bis 999.0]
#define LBYTE_MECHANIK_UMKEHRSPIEL_X_LONG						0x04	// Schritte	   (0) [0 bis 500]
#define LBYTE_MECHANIK_UMKEHRSPIEL_Y_LONG						0x05	// Schritte	   (0) [0 bis 500]
#define LBYTE_MECHANIK_UMKEHRSPIEL_Z_LONG						0x06	// Schritte	   (0) [0 bis 500]
#define LBYTE_MECHANIK_UMKEHRSPIEL_C_LONG						0x07	// Schritte	   (0) [0 bis 500]
#define LBYTE_MECHANIK_RICHTUNGSUMKEHR_LONG						0x08	// (0,0,0,0) [0-Aus,1-An]
#define LBYTE_MECHANIK_VERFAHRBEREICH_VON_LONG					0x09	// mm (0,0,0,0)		  [-32767 bis +32767]
#define LBYTE_MECHANIK_VERFAHRBEREICH_BIS_LONG					0x0A	// mm (100,100,50,50) [-32767 bis +32767]
#define LBYTE_MECHANIK_PARKPOSITION_LONG	    				0x0B	// mm (0,0,0,0)		  [-32767 bis +32767]
#define LBYTE_MECHANIK_NULLPUNKT_LONG		    				0x0C	// mm (0,0,0,0)		  [-32767 bis +32767]
#define LBYTE_MECHANIK_ACHSENCONFIGURATION_UCHAR				0x0D	// (0,0,0,0) [0-linear,1-rotatorisch,2-deaktiviert]
//------------------------------------------------------------------------------------------------------
#define HBYTE_SONSTIGE									0x05
#define LBYTE_SONSTIGE_WERKZEUGWECHSEL_LONG		    			0x00	// (4)	[1-ignorieren,2-an Parkposition,3-an aktueller Position,4-nur Parameter bernehmen]
#define LBYTE_SONSTIGE_REFERENZFAHRTZEITPUNKT_LONG    			0x01	// (1)	[1-nur manuel,2-auch beim Einschalten,3-zustzlich vor Programmstart]
#define LBYTE_SONSTIGE_SPINDELHOCHLAUF_LONG			   			0x02	// Zeit in ms (0)  [0 bis 5000]
#define LBYTE_SONSTIGE_WERKZEUGANSCHNITT_LONG		   			0x03	// Zeit in ms (0)  [0 bis 5000]
#define LBYTE_SONSTIGE_UNBEKANNTEPROGRAMMBEFEHLE_LONG			0x04	// (1)  [1-ignorieren,2-abbrechen,3-fragen]
#define LBYTE_SONSTIGE_CONTROLLERNAME_CHAR						0x05	// ("NC-Pilot USB    ")  [16 char]
#define LBYTE_SONSTIGE_SICHERHEITSABSTAND_LONG					0x06	// mm (0)			  [0 bis 255]
#define LBYTE_SONSTIGE_WEITERE_LONG								0x07	// noch nicht vorhanden (0)
//------------------------------------------------------------------------------------------------------
// Achtung! Die nchsten HBYTE HBYTE Combinationen sind NUR fr "ParameterLesen" erlaubt.
#define HBYTE_ALLINONE									0x0F
#define LBYTE_ALLINONE_AUFLOESUNG_FLOAT		    				0x00	// 
#define HBYTE_ALLINONE_START_FAHR_MANUELL_FLOAT    				0x01	// 
#define LBYTE_ALLINONE_REFERENZ_EILGANG_FLOAT		    		0x02	// 
//------------------------------------------------------------------------------------------------------

// Flow Control Flags
#define FC_DTRDSR		0x01
#define FC_RTSCTS		0x02
#define FC_XONXOFF		0x04

// ASCII Definitions
#define ASCII_BEL		0x07
#define ASCII_BS		0x08
#define ASCII_LF		0x0A
#define ASCII_CR		0x0D
#define ASCII_XON		0x11
#define ASCII_XOFF		0x13

// Falls NCStepOpenConnectionPort oder NCStepOpenConnectionAuto oder NCStepOpenConnectionName
// den return value = 0 (failed) zuruckgeben, kann man im NCStepCommPortSettings->errorCode
// die genaue Ursache sehen
//
//#define NO_ERROR									0x00
#define ERROR_OPEN_CONNECTION						0x01
#define ERROR_AM_PORT_IST_KEIN_CONTROLLER			0x02
#define ERROR_OPEN_AUTO_KEIN_CONTROLLER_GEFUNDEN	0x03
#define ERROR_OPEN_NAME_KEIN_CONTROLLER_GEFUNDEN	0x04

#define END_OF_FRAME 0xA7 // ''

// Im Antwortframe, Byte 26 knnen folgende Fehler auftreten:
//#define NO_ERROR								0x00
#define ERROR_BAW_BEFEHLSPUFFER_NICHT_LEER	    0x01
#define ERROR_BAW_ACHSEN_FAHREN_NOCH			0x02
#define ERROR_BAW_MENUEPUNKT_BEFEHL_UNZULAESSIG	0x03
#define ERROR_SERIAL_ZWISCHENZUSTAND    	    0x04
#define ERROR_AUTO_X_UNTERE_GRENZE_ERREICHT     0x11
#define ERROR_AUTO_X_OBERE_GRENZE_ERREICHT      0x12
#define ERROR_REFERENZ_X_ENDSCHALTER            0x13
#define ERROR_AUTO_Y_UNTERE_GRENZE_ERREICHT     0x21
#define ERROR_AUTO_Y_OBERE_GRENZE_ERREICHT      0x22
#define ERROR_REFERENZ_Y_ENDSCHALTER            0x23
#define ERROR_AUTO_Z_UNTERE_GRENZE_ERREICHT     0x31
#define ERROR_AUTO_Z_OBERE_GRENZE_ERREICHT      0x32
#define ERROR_REFERENZ_Z_ENDSCHALTER            0x33
#define ERROR_AUTO_C_UNTERE_GRENZE_ERREICHT     0x41
#define ERROR_AUTO_C_OBERE_GRENZE_ERREICHT      0x42
#define ERROR_REFERENZ_C_ENDSCHALTER            0x43
#define ERROR_REFERENZ_NOTAUS                   0x53
#define ERROR_REFERENZ_ANZAHL_ACHSEN_FALSCH     0x0A
#define ERROR_PARAMETER_OUT_OF_RANGE            0x71
#define ERROR_PARAMETER_NUMMER_UNGUELTIG        0x91
#define ERROR_NOTSTOP                           0x99

/*
// in WINBASE.H
typedef struct _OVERLAPPED {
    DWORD   Internal;
    DWORD   InternalHigh;
    DWORD   Offset;
    DWORD   OffsetHigh;
    HANDLE  hEvent;
} OVERLAPPED, *LPOVERLAPPED;
*/

typedef struct TagCommSet
{
	HANDLE			hCommDev;
	char			comPort[8];
	char			controllerName[16];
	unsigned char	af[32];
	unsigned char   afModusAktuell;
	unsigned char   afEingaenge;
	unsigned char   afAusgaenge;
	long			afXist;
	long			afYist;
	long			afZist;
	long			afCist;
	unsigned char   afBasisEinheit;
	unsigned char   afBefehlsPufferFuellstand;
	unsigned char   afAntwortFrameFlag;
	unsigned char   afInput3;
	unsigned char   afOutput3;
	unsigned char   afBefehlsZustand;
	unsigned char   afError;
	unsigned char   afFrameCNT;
	unsigned long	ulBaudRate;
	unsigned char	frameCount;		//	Frame Counter 0 bis 255.
	unsigned char	errorCode;
	unsigned char	allgEingaengeDeaktivieren;
	int				connected;
	int             transfer;
	HANDLE			hWatchThread;
	long			lWatchThreadID;
	HANDLE			hSendThread;
	long			lSendThreadID;
    HANDLE          hReadMutex;
	unsigned char	ucByteSize;
	unsigned char	ucParity;
	unsigned char	ucStopBits;
	unsigned char	ucFlowCtrl;
	OVERLAPPED		osWrite;
	OVERLAPPED		osRead;

// internal communication members
    unsigned char sendQueue[256][64];
    int sendQueuePopIndex;
    int sendQueuePushIndex;

    HANDLE hSendQueueMutex;
    HANDLE hSendQueueEvent;
    HANDLE hWaitForParameterEvent;

    BOOL bSendStatusAbfrage;

} NCStepCommPortSettings;

typedef void (STDCALL *STATUS_CALLBACK_FUNC)(NCStepCommPortSettings*);

LIBSPEC void STDCALL SetStatusNotificationCallback(STATUS_CALLBACK_FUNC func);

//
// INPUT :
// pNCStepCommPortSettings
//
// RETURN :
// 0			- failed
// 1			- success
//
// Es wird der GENAU definierte Comport geffnet (z.B. COM4)
LIBSPEC int STDCALL  NCStepOpenConnectionPort(NCStepCommPortSettings *pNCStepCommPortSettings, unsigned int PortNo);
//
// INPUT :
// pNCStepCommPortSettings
//
// RETURN :
// 0			- failed
// 1			- success
//
// Ab dem COM1 bis COM8 wird nach dem Controller gesucht.
// Es wird der erste gefundene genommen, controllerName wird nicht analysiert.
LIBSPEC int STDCALL  NCStepOpenConnectionAuto(NCStepCommPortSettings *pNCStepCommPortSettings);
//
// INPUT :
// pNCStepCommPortSettings
//
// RETURN :
// 0			- failed
// 1			- success
//
// Ab dem COM1 bis COM8 wird nach dem Controller mit dem bestimmten Namen gesucht.
LIBSPEC int STDCALL  NCStepOpenConnectionName(NCStepCommPortSettings *pNCStepCommPortSettings, char *controllerName);
//
// INPUT :
// pNCStepCommPortSettings
//
// RETURN :
// 0			- failed
// 1			- success
//
LIBSPEC int STDCALL NCStepOpenConnection4FirmwareUpdate(NCStepCommPortSettings *pNCStepCommPortSettings);

//
// INPUT :
// pNCStepCommPortSettings
//
// RETURN :
// 0			- failed
// 1			- success
//
LIBSPEC int STDCALL  NCStepCloseConnection(NCStepCommPortSettings *pNCStepCommPortSettings);

//
// INPUT :
// pNCStepCommPortSettings
//
// RETURN :
// 0			- failed
// 1			- success
//
// Merken: Die Funktion NCStepCloseTransfer MUSS VOR NCStepCloseConnection kommen
//
LIBSPEC int STDCALL NCStepCloseTransfer(NCStepCommPortSettings *pNCStepCommPortSettings);

//
// Die zwei Funktionen werden in NCPilotSeatSDI fr FirmwareUpdate benutzt
//
LIBSPEC int STDCALL  NCStepWriteChar(NCStepCommPortSettings *pNCStepCommPortSettings, char *c_sf, unsigned long ulBytesToWrite);
LIBSPEC int STDCALL  NCStepReadChar(NCStepCommPortSettings *pNCStepCommPortSettings, char *c_af, unsigned long ulBytesToRead);

LIBSPEC int STDCALL InitCommPortSettings(NCStepCommPortSettings *pNCStepCommPortSettings);

int NCStepOpenConnection(NCStepCommPortSettings *pNCStepCommPortSettings);
int NCStepOpenTransfer(NCStepCommPortSettings *pNCStepCommPortSettings);

int NCStepWriteCommBlock(NCStepCommPortSettings *pNCStepCommPortSettings, unsigned char *sf, unsigned long ulBytesToWrite);
int NCStepReadCommBlock(NCStepCommPortSettings *pNCStepCommPortSettings, unsigned char *af, unsigned long ulBytesToRead);
int NCStepFlushCommBlock(NCStepCommPortSettings *pNCStepCommPortSettings, unsigned char *af);

int NCStepCommSendProc(NCStepCommPortSettings *pNCStepCommPortSettings);
int NCStepCommWatchProc(NCStepCommPortSettings *pNCStepCommPortSettings);

void PushSendQueue(NCStepCommPortSettings *pNCStepCommPortSettings, unsigned char* cmd);
unsigned char* PopSendQueue(NCStepCommPortSettings *pNCStepCommPortSettings);

int InitStatusAbfrage(NCStepCommPortSettings *pNCStepCommPortSettings, unsigned char *af);
int InitBetriebsArtenWechsel(NCStepCommPortSettings *pNCStepCommPortSettings, unsigned char ziel_ba, unsigned char *af);
int InitParameterLesen(NCStepCommPortSettings *pNCStepCommPortSettings, unsigned char Hbyte, unsigned char Lbyte, unsigned char *af);

//
// INPUT :
// pNCStepCommPortSettings
// BahnV         - Bahngeschwindigkeit, long. Zum Verwenden des Default-Wertes 0 eintragen.
//				   Default ist die in Men "Einstellungen" - "Geschwindigkeiten" -
//                 "Fahrgeschwindigkeit" eingestellte Vorschubgeschwindigkeit.
// AnzKoordPaare - 1 bis 6
// x bzw z		 - Array mit 6 Elementen von Typ "long"
// y bzw c		 - Array mit 6 Elementen von Typ "long"
// rampenbits	 - Sieh Bedienungsanleitung "NC-Pilot USB" - "bertragungsprotokoll"
//
// OUTPUT :
//
LIBSPEC int STDCALL  FahreRelativ_XY_Schritte(NCStepCommPortSettings *pNCStepCommPortSettings, long BahnV, unsigned char AnzKoordPaare, long *x, long *y, unsigned char rampenbits);
LIBSPEC int STDCALL  FahreRelativ_ZC_Schritte(NCStepCommPortSettings *pNCStepCommPortSettings, long BahnV, unsigned char AnzKoordPaare, long *z, long *c, unsigned char rampenbits);

//
// INPUT :
// pNCStepCommPortSettings
// BahnV         - Bahngeschwindigkeit, float. Zum Verwenden des Default-Wertes 0.0 eintragen.
//				   Default ist die in Men "Einstellungen" - "Geschwindigkeiten" -
//                 "Fahrgeschwindigkeit" eingestellte Vorschubgeschwindigkeit.
// AnzKoordPaare - 1 bis 6
// x bzw z		 - Array mit 6 Elementen von Typ "float"
// y bzw c		 - Array mit 6 Elementen von Typ "float"
//
// OUTPUT :
//
LIBSPEC int STDCALL  FahreRelativ_XY_mm(NCStepCommPortSettings *pNCStepCommPortSettings, float BahnV, unsigned char AnzKoordPaare, float *x, float *y, unsigned char rampenbits);
LIBSPEC int STDCALL  FahreRelativ_ZC_mm(NCStepCommPortSettings *pNCStepCommPortSettings, float BahnV, unsigned char AnzKoordPaare, float *z, float *c, unsigned char rampenbits);

//
// INPUT :
// pNCStepCommPortSettings
// x			 - Nullpunkt X-Achse, long
// y			 - Nullpunkt Y-Achse, long
// z			 - Nullpunkt Z-Achse, long
// c			 - Nullpunkt C-Achse, long
//
// OUTPUT :
//
LIBSPEC int STDCALL  NullPunktSetzen_Schritte(NCStepCommPortSettings *pNCStepCommPortSettings, long x, long y, long z, long c);

//
// INPUT :
// pNCStepCommPortSettings
// x			 - Nullpunkt X-Achse, float
// y			 - Nullpunkt Y-Achse, float
// z			 - Nullpunkt Z-Achse, float
// c			 - Nullpunkt C-Achse, float
//
// OUTPUT :
// 
LIBSPEC int STDCALL  NullPunktSetzen_mm(NCStepCommPortSettings *pNCStepCommPortSettings, float x, float y, float z, float c);

// NUR die Riehenfolge der referenzierten Achsen kann mit Hilfe dieser Funktion gendert werden.
// Die Richtung der Achsen bleibt so, wie in "Einstellungen" definiert ist.
// ("+" positive, "-" negative, "*" Achse wird nicht referenziert)
//
// INPUT :
// pNCStepCommPortSettings
// Anz_Achs				- Anzahl der Achsen (0 <= No_Achs <= 4).
// Anz_Achs = 0			- alle 4 Achsen werden referenziert. Die Richtung und Riehenfolge
//						  sind im diesem Fall aus Men "Einstellungen" - "Mechanik" - 
//						  "Richtung/Sequenz Referenzfahrt" zu bernehmen.
//						  ("+" positive, "-" negative, "*" Achse wird nicht referenziert)
// Anz_Achs = 1,2,3,4   - Die angegebene Anzahl Achsen werden referenziert.
//						  Die Riehenfolge ist aus dem Parameter "Nummer" und
//                        die Richtung ist aus Men "Einstellungen" - "Mechanik" - 
//						  "Richtung/Sequenz Referenzfahrt"zu bernehmen.
//						  ("+" positive, "-" negative, "*" Achse wird nicht referenziert)
// Nummer[0]			- Nummer der ersten Achse  (0=X, 1=Y, 2=Z, 3=C)
// Nummer[1]			- Nummer der zweiten Achse (0=X, 1=Y, 2=Z, 3=C)
// Nummer[2]			- Nummer der dritten Achse (0=X, 1=Y, 2=Z, 3=C)
// Nummer[3]			- Nummer der vierten Achse (0=X, 1=Y, 2=Z, 3=C)
//
// OUTPUT :
//
LIBSPEC int STDCALL  Referenzfahrt(NCStepCommPortSettings *pNCStepCommPortSettings, unsigned char Anz_Achs, unsigned char *Nummer);

//
// INPUT :
// pNCStepCommPortSettings
//
// OUTPUT :
//
LIBSPEC int STDCALL  ParkPositionAnfahren(NCStepCommPortSettings *pNCStepCommPortSettings);

//
// INPUT :
// pNCStepCommPortSettings
// sp			 - Spindel 0=aus, 1=ein
// kuh			 - Khlung 0=aus, 1=ein
//
// OUTPUT :
//
LIBSPEC int STDCALL  SpindelKuhlungSetzen(NCStepCommPortSettings *pNCStepCommPortSettings, unsigned char sp, unsigned char kuh);

//
// INPUT :
// pNCStepCommPortSettings
// output3		 - 
//
// OUTPUT :
//
LIBSPEC int STDCALL  AllgemeineAusgaeneSetzen(NCStepCommPortSettings *pNCStepCommPortSettings, unsigned char output3);

LIBSPEC int STDCALL  GetPosition_Schritte(NCStepCommPortSettings *pNCStepCommPortSettings, long *ist_steps, unsigned char* Error);
LIBSPEC int STDCALL  GetPosition_mm(NCStepCommPortSettings *pNCStepCommPortSettings, float *ist_mm, unsigned char* Error);

LIBSPEC int STDCALL GetStatus_Schritte(NCStepCommPortSettings *pNCStepCommPortSettings, unsigned char *ModusAktuell, unsigned char *Eingaenge, unsigned char *Ausgaenge,
									   long *lXist, long *lYist, long *lZist, long *lCist, unsigned char *BefehlsPufferFuellstand,
									   unsigned char *Input3, unsigned char *Output3, unsigned char *Error);
LIBSPEC int STDCALL GetStatus_mm(NCStepCommPortSettings *pNCStepCommPortSettings, unsigned char *ModusAktuell, unsigned char *Eingaenge, unsigned char *Ausgaenge,
								 float *fXist, float *fYist, float *fZist, float *fCist, unsigned char *BefehlsPufferFuellstand,
								 unsigned char *Input3, unsigned char *Output3, unsigned char *Error);
//
// INPUT :
// pNCStepCommPortSettings
//
// OUTPUT :
//
LIBSPEC int STDCALL  FehlerQuitieren(NCStepCommPortSettings *pNCStepCommPortSettings);

//
// INPUT :
// pNCStepCommPortSettings
//
// OUTPUT :
//
LIBSPEC int STDCALL  NotStop_ohneBremsrampe(NCStepCommPortSettings *pNCStepCommPortSettings);

//
// INPUT :
// pNCStepCommPortSettings
//
// OUTPUT :
//
LIBSPEC int STDCALL  NotHalt_mitBremsrampe(NCStepCommPortSettings *pNCStepCommPortSettings);

//
// INPUT :
// pNCStepCommPortSettings

// ziel_ba		 - 0x01:BA_WECHSEL_PARAMETER - Parameterbertragung,
//                 0x02:BA_WECHSEL_AUTOMATIK - Automatikbetrieb
//
// OUTPUT :
//
LIBSPEC int STDCALL  BetriebsArtenWechsel(NCStepCommPortSettings *pNCStepCommPortSettings, unsigned char ziel_ba);

// Auf die Funkzionen "ParameterAendern_long", "ParameterAendern_4_longs"
// "ParameterAendern_float" und "ParameterAendern_Richtung_Sequenz_ReferenzFahrt"
// wird mit dem normalen Antwortframe geantwortet
// (s.Tabele 2 der "Bedienungsanleitung")
//
// INPUT :
// pNCStepCommPortSettings
// Hbyte		 - aus den #define HBYTE_... 
// Lbyte		 - aus den #define LBYTE_...
// param		 - Parameterwert von Typ "long", wird ber Hbyte und Lbyte adressiert
//
LIBSPEC int STDCALL  ParameterAendern_long(NCStepCommPortSettings *pNCStepCommPortSettings, unsigned char Hbyte, unsigned char Lbyte, long param);

//
// INPUT :
// pNCStepCommPortSettings
// Hbyte		 - aus den #define HBYTE_... 
// Lbyte		 - aus den #define LBYTE_...
// paramX		 - Parameterwert von Typ "long", wird ber Hbyte und Lbyte adressiert
// paramY		 - Parameterwert von Typ "long", wird ber Hbyte und Lbyte adressiert
// paramZ		 - Parameterwert von Typ "long", wird ber Hbyte und Lbyte adressiert
// paramC		 - Parameterwert von Typ "long", wird ber Hbyte und Lbyte adressiert
//
// OUTPUT :
//
LIBSPEC int STDCALL  ParameterAendern_4_longs(NCStepCommPortSettings *pNCStepCommPortSettings, unsigned char Hbyte, unsigned char Lbyte,
											  long paramX, long paramY, long paramZ, long paramC);
//
// INPUT :
// pNCStepCommPortSettings
// Hbyte		 - aus den #define HBYTE_... 
// Lbyte		 - aus den #define LBYTE_...
// paramX		 - Parameterwert von Typ "unsigned char", wird ber Hbyte und Lbyte adressiert
// paramY		 - Parameterwert von Typ "unsigned char", wird ber Hbyte und Lbyte adressiert
// paramZ		 - Parameterwert von Typ "unsigned char", wird ber Hbyte und Lbyte adressiert
// paramC		 - Parameterwert von Typ "unsigned char", wird ber Hbyte und Lbyte adressiert
//
// OUTPUT :
//
LIBSPEC int STDCALL  ParameterAendern_4_uchar(NCStepCommPortSettings *pNCStepCommPortSettings, unsigned char Hbyte, unsigned char Lbyte,
											  unsigned char paramX, unsigned char paramY, unsigned char paramZ, unsigned char paramC);
//
// INPUT :
// pNCStepCommPortSettings
// Hbyte		 - aus den #define HBYTE_... 
// Lbyte		 - aus den #define LBYTE_...
// param		 - Parameterwert von Typ "float", wird ber Hbyte und Lbyte adressiert
//
// OUTPUT :
//
LIBSPEC int STDCALL  ParameterAendern_float(NCStepCommPortSettings *pNCStepCommPortSettings, unsigned char Hbyte, unsigned char Lbyte, float param);

//
// INPUT :
// pNCStepCommPortSettings
// Hbyte		 - aus den #define HBYTE_... 
// Lbyte		 - aus den #define LBYTE_...
// cname		 - Controllername, GENAU 16 char
//
// OUTPUT :
//
LIBSPEC int STDCALL  ParameterAendern_ControllerName(NCStepCommPortSettings *pNCStepCommPortSettings, unsigned char Hbyte, unsigned char Lbyte, char *cname);

//
// INPUT :
// pNCStepCommPortSettings
// Hbyte		 - aus den #define HBYTE_... 
// Lbyte		 - aus den #define LBYTE_...
// richtung_achse1	-	Richtung in der fr die erste zu referenzierenden Achse 
//						nach dem Schalter gesucht wird 
//						(0-positive, 1-negative, 2-Achse wird nicht referenziert)
// richtung_achse2	-	Richtung in der fr die zweite zu referenzierenden Achse 
//						nach dem Schalter gesucht wird 
//						(0-positive, 1-negative, 2-Achse wird nicht referenziert)
// richtung_achse3	-	Richtung in der fr die dritte zu referenzierenden Achse 
//						nach dem Schalter gesucht wird
//						(0-positive, 1-negative, 2-Achse wird nicht referenziert)
// richtung_achse4	-	Richtung in der fr die vierte zu referenzierenden Achse 
//						nach dem Schalter gesucht wird
//						(0-positive, 1-negative, 2-Achse wird nicht referenziert)
// achse1	- Nummer der  ersten zu referenzierenden Achse  (0=X, 1=Y, 2=Z, 3=C)		
// achse2	- Nummer der zweiten zu referenzierenden Achse  (0=X, 1=Y, 2=Z, 3=C)
// achse3	- Nummer der dritten zu referenzierenden Achse  (0=X, 1=Y, 2=Z, 3=C)
// achse4	- Nummer der vierten zu referenzierenden Achse  (0=X, 1=Y, 2=Z, 3=C)
//
// OUTPUT :
//
LIBSPEC int STDCALL  ParameterAendern_Richtung_Sequenz_ReferenzFahrt(NCStepCommPortSettings *pNCStepCommPortSettings, unsigned char Hbyte, unsigned char Lbyte,
													unsigned char richtung_achse1, unsigned char richtung_achse2, unsigned char richtung_achse3, unsigned char richtung_achse4,
													unsigned char achse1, unsigned char achse2, unsigned char achse3, unsigned char achse4);

// Auf die Funkzion "ParameterLesen" wird mit dem Antwortframe fr Parameter geantwortet.
// (s.Tabele 4 der "Bedienungsanleitung").
//
// INPUT :
// pNCStepCommPortSettings
// Hbyte		 - aus den #define HBYTE_... 
// Lbyte		 - aus den #define LBYTE_...
//
// OUTPUT :
// daten		 - Array mit 16 Elementen von Typ "unsigned char".
//
LIBSPEC int STDCALL  ParameterLesen(NCStepCommPortSettings *pNCStepCommPortSettings, unsigned char Hbyte, unsigned char Lbyte, unsigned char *daten);

#ifdef  __cplusplus
}
#endif
#endif
